/*
 *	main.c
 *
 *	stetris - VvegX
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Tue Aug  8 05:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/* * ʃCAEg
 * - pꕶ4x4sNZłB
 * - g̓OtBbNʂłB
 * - tB[hƕ̓eLXgłB
 * - ݂̃ubNNEXTubN̓XvCgłB
 * - eLXgʂ͏cLɃXN[܂B
 *
 *	 @01234567890123456789012345678901
 *	 
 *	0  +--------------++----------+  
 *	1  |@mdws@@|||  
 *	2  |@mdws@@|||  
 *	3  |@@  @@|||  
 *	4  |@@  @@|||  
 *	5  |@@  @@|||  
 *	6  |@@  @@|||  
 *	7  |@khmd@@|||  
 *	8  |@khmd@@|||  
 *	9  |@OOOOO@|||  
 *	0  |@OOOOO@|||  
 *	1  |  kdudk  |||  
 *	2  |  kdudk  |||  
 *	3  |  OOOOO  |||  
 *	4  |  OOOOO  |||  
 *	5  +--------------+||  
 *	6  +--------------+||  
 *	7  |PoOOOOO|||  
 *	8  |PoOOOOO|||  
 *	9  |ghOOOOO|||  
 *	0  |ghOOOOO|||  
 *	1  +--------------++----------+  
 *	 
 */

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		60		/* t[[g */
#define SEC(s)		((int)(FPS * (s))) /* b->t[ϊ */
#define N_OBJS		64		/* XvCgv[ */

/* tB[h */
#define FIELD_COLS	10		/* tB[h */
#define FIELD_ROWS	20		/* tB[hc */
typedef unsigned char FIELD[FIELD_ROWS][FIELD_COLS];

/* ubN */
#define BLOCK_COLS	4		/* ubN */
#define BLOCK_ROWS	4		/* ubNc */
typedef unsigned char BLOCK[BLOCK_ROWS][BLOCK_COLS];
BLOCK blocks[][4] = {
#define _ 0
#define O 1
	/* 0 */
	{{{_,_,_,_},
	  {O,O,O,O},
	  {_,_,_,_},
	  {_,_,_,_}},
	 {{_,_,O,_},
	  {_,_,O,_},
	  {_,_,O,_},
	  {_,_,O,_}},
	 {{_,_,_,_},
	  {O,O,O,O},
	  {_,_,_,_},
	  {_,_,_,_}},
	 {{_,_,O,_},
	  {_,_,O,_},
	  {_,_,O,_},
	  {_,_,O,_}}},
	/* 1 */
	{{{_,_,_,_},
	  {_,O,O,_},
	  {_,O,O,_},
	  {_,_,_,_}},
	 {{_,_,_,_},
	  {_,O,O,_},
	  {_,O,O,_},
	  {_,_,_,_}},
	 {{_,_,_,_},
	  {_,O,O,_},
	  {_,O,O,_},
	  {_,_,_,_}},
	 {{_,_,_,_},
	  {_,O,O,_},
	  {_,O,O,_},
	  {_,_,_,_}}},
	/* 2 */
	{{{_,_,_,_},
	  {_,O,_,_},
	  {O,O,O,_},
	  {_,_,_,_}},
	 {{_,O,_,_},
	  {O,O,_,_},
	  {_,O,_,_},
	  {_,_,_,_}},
	 {{O,O,O,_},
	  {_,O,_,_},
	  {_,_,_,_},
	  {_,_,_,_}},
	 {{_,O,_,_},
	  {_,O,O,_},
	  {_,O,_,_},
	  {_,_,_,_}}},
	/* 3 */
	{{{_,_,_,_},
	  {O,O,O,_},
	  {_,_,O,_},
	  {_,_,_,_}},
	 {{_,O,O,_},
	  {_,O,_,_},
	  {_,O,_,_},
	  {_,_,_,_}},
	 {{_,_,_,_},
	  {O,_,_,_},
	  {O,O,O,_},
	  {_,_,_,_}},
	 {{_,O,_,_},
	  {_,O,_,_},
	  {O,O,_,_},
	  {_,_,_,_}}},
	/* 4 */
	{{{_,_,_,_},
	  {O,O,O,_},
	  {O,_,_,_},
	  {_,_,_,_}},
	 {{_,O,_,_},
	  {_,O,_,_},
	  {_,O,O,_},
	  {_,_,_,_}},
	 {{_,_,_,_},
	  {_,_,O,_},
	  {O,O,O,_},
	  {_,_,_,_}},
	 {{O,O,_,_},
	  {_,O,_,_},
	  {_,O,_,_},
	  {_,_,_,_}}},
	/* 5 */
	{{{_,_,_,_},
	  {O,O,_,_},
	  {_,O,O,_},
	  {_,_,_,_}},
	 {{_,_,O,_},
	  {_,O,O,_},
	  {_,O,_,_},
	  {_,_,_,_}},
	 {{_,_,_,_},
	  {O,O,_,_},
	  {_,O,O,_},
	  {_,_,_,_}},
	 {{_,_,O,_},
	  {_,O,O,_},
	  {_,O,_,_},
	  {_,_,_,_}}},
	/* 6 */
	{{{_,_,_,_},
	  {_,O,O,_},
	  {O,O,_,_},
	  {_,_,_,_}},
	 {{O,_,_,_},
	  {O,O,_,_},
	  {_,O,_,_},
	  {_,_,_,_}},
	 {{_,_,_,_},
	  {_,O,O,_},
	  {O,O,_,_},
	  {_,_,_,_}},
	 {{O,_,_,_},
	  {O,O,_,_},
	  {_,O,_,_},
	  {_,_,_,_}}},
#undef _
#undef O
};
#define N_BLOCKS	(sizeof blocks / sizeof *blocks)

/* Q[f[^ */
typedef struct _GAMEDATA {
	int seed;		/* V[h */
	int score;		/* XRA */
	int level;		/* ݂̃x */
	int line;		/* C */
	int next;		/* ̃ubN̎ */
	int type;		/* ݂̃ubN̎ */
	int rot;		/* ݂̃ubN̉] */
	int x, y;		/* ݂̃ubN̈ʒu */
	FIELD field;		/* tB[h */
} GAMEDATA;

/* x` */
typedef struct _LEVEL {
	int next_line;		/* C玟̃xɐiނH */
	int fall_wait;		/* EFCg */
} LEVEL;
LEVEL levels[] = {
	{   5, SEC(0.5  ) },	/*  0 */
	{  10, SEC(0.25 ) },	/*  1 */
	{  20, SEC(0.125) },	/*  2 */
	{  30, SEC(0.05 ) },	/*  3 */
	{  40, SEC(0.25 ) },	/*  4 */
	{  50, SEC(0.125) },	/*  5 */
	{  60, SEC(0.05 ) },	/*  6 */
	{  70, SEC(0    ) },	/*  7 */
	{  80, SEC(0.125) },	/*  8 */
	{  90, SEC(0.05 ) },	/*  9 */
	{ 100, SEC(0    ) },	/* 10 */
};
#define N_LEVELS	(sizeof levels / sizeof *levels)

/* ^C~O` */
#define FLOAT_WAIT	SEC(0.25)	/* o`܂ł̃EFCg */
//#define FALL_WAIT	SEC(0.25)	/* EFCg */xƂɒ`
#define FALL_WAIT	(gd.level < N_LEVELS ? levels[gd.level].fall_wait : 0)
#define LAND_WAIT	SEC(0.25)	/* n`ڒn܂ł̃EFCg */
#define LINE_WAIT	SEC(0.75)	/* s̓_Ŏ */
#define NEXT_WAIT	SEC(0.25)	/* ڒn`NEXTo܂ł̃EFCg */

/* TEh */
#define SND_BLOCK	3
#define SND_LAND	1
#define SND_ERASE	0
#define SND_GAMEOVER	2

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

int hiscore;		/* nCXRA */
GAMEDATA gd;		/* Q[f[^ */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void spcls(int obj);
int demo();
void game();
int game_rand();
void screen_disp();
int block_disp(int obj, int x, int y, int type, int rot);
int field_disp(int obj);
int info_disp(int obj);
int hit_test(int x, int y, int type, int rot);
int land_test();
void block_put();
int line_test();
void line_erase();
void block_work();

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_STR	"PAUSE!"	/* PAUSEbZ[W */
#define PAUSE_LEN	6		/* PAUSEbZ[W */
#define PAUSE_X		5		/* \ʒu */
#define PAUSE_Y		5		/* \ʒu */

	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;
	unsigned char save[PAUSE_LEN];

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(joy_rep[i] >= SEC(0.33) && joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

		/* PAUSEB */
		if(joy & TRG_START) {
			thread_lock();	/* pclSprite*()gpɃXbh؂ւȂ悤 */
			pause ^= 1;	/* PAUSEԐ؂ւ */
			if(pause & 1) {	/* PAUSE IN */
				/* PAUSEbZ[W\̕ޔB */
				for(i = 0; i < PAUSE_LEN; i++) {
					save[i] = pclSpriteBGGetCharacter(0, PAUSE_X + i, PAUSE_Y);
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̕𕜋AB */
				for(i = 0; i < PAUSE_LEN; i++) {
					pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, save[i]);
				}
			}
			thread_unlock();/* pclSprite*()gpÎŃXbh؂ւ */
		}
		if(!(pause & 1)) break;

//̃AvP[V̓eLXgƃOtBbN̗DxtȂ̂ŁAPAUSEbZ[W͕\܂B
//		/* PAUSEbZ[W_ŕ\B */
//		thread_lock();	/* pclSprite*()gpɃXbh؂ւȂ悤 */
//		for(i = 0; i < PAUSE_LEN; i++) {
//			pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, pause & 2 ? PAUSE_STR[i] : 0);
//		}
//		pause ^= 2;
//		thread_unlock();/* pclSprite*()gpÎŃXbh؂ւ */
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	spcls
 ****************************************************************************/

/* cXvCgv[NA܂B */
void
spcls(int obj)
{
	while(obj < N_OBJS) sppos(obj++, -8, -8);
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, i, x, y, mode_save;

	/* eLXgʃXN[ɖ߂܂B */
	thread_lock();
	pclSpriteBGSetPosition(0, 0, 0);
	thread_unlock();

	/* ʃNAB */
	cls();
	fill(0, 0, DISP_X-1, DISP_Y-1, -1);
	spcls(0);

	/* ꎞIɃOtBbNʂ̃CXN[ONB */
	thread_lock();
	mode_save = pclSpriteDispMode(INVALIDVAL);
	pclSpriteDispMode(mode_save | LINE_BG1);
	thread_unlock();

	/* CXN[̏l0Ȃ̂ŁAC0\܂B
	 * IɑSC̃CXN[lݒ肷Kv܂B
	 */
	thread_lock();
	for(y = 0; y < DISP_Y; y++) pclSpriteBGSetLinePosition(1, y, 0, y);
	thread_unlock();

	/* ^Cg\BiCXN[ŌX܂j */
	y = 30;
	x = (DISP_X - 5 * 6) / 2;
	symbol(x + 1, y, "SIMPLE", 0, 2);
	symbol(x    , y, "SIMPLE", 0, 1);
	symbol(x - 1, y, "SIMPLE", 0, 3);
	thread_lock();
	for(i = 0; i < 10; i++) pclSpriteBGSetLinePosition(1, y + i, i / 2 - 2, y + i);
	thread_unlock();
	y += 10;
	x = (DISP_X - 8 * 6) / 2;
	symbol(x + 1, y, "TETRIS", 1, 2);
	symbol(x    , y, "TETRIS", 1, 1);
	symbol(x - 1, y, "TETRIS", 1, 3);
	thread_lock();
	for(i = 0; i < 16; i++) pclSpriteBGSetLinePosition(1, y + i, i / 2 - 4, y + i);
	thread_unlock();

	/* XRA\B */
	locate(0, 0); printstr("1PSCORE");
	locate(0, 1); siprintf("%7d", gd.score);
	locate(9, 0); printstr("HISCORE");
	locate(9, 1); siprintf("%7d", hiscore);

	for(;;) {
		schedule();

		/* Q[JnA܂͏IH */
		if(joy & TRG_A     ) { result =  0; break; }
		if(joy & TRG_SELECT) { result = -1; break; }

		/* vvg\B */
		locate(3,  9); printstr(now % SEC(0.75) < SEC(0.5) ? "[ A ] START" : "           ");
		locate(3, 10); printstr(now % SEC(0.75) < SEC(0.5) ? "[SEL] EXIT " : "           ");
	}

	/* \ݒ𕜌B */
	thread_lock();
	pclSpriteDispMode(mode_save);
	thread_unlock();

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	int cnt, obj, i, j, x, y;
	BLOCK* block;

	sound(SND_GAMEOVER); /* Jn */

	/* eLXgʂ͏cLÂ炵܂B */
	thread_lock();
	pclSpriteBGSetPosition(0, 4, 4);
	thread_unlock();

	/* Q[B */
	memset(&gd, 0, sizeof gd);
	gd.seed = msec();

	/* ʂ̌Œ蕔`܂B */
	screen_disp();
	field_disp(-1);

	/* JnÕbZ[W\B */
	for(i = 0; i < SEC(2); i++) {
		schedule();
		if(i % SEC(0.5) < SEC(0.33)) {
			obj = 0;
			      field_disp(-1); /* ubN\Ȃ */
			obj = info_disp(obj);
			spcls(obj);
			/* tB[hɏ㏑B */
			locate(10, 5);
			printstr("READY");
		} else {
			obj = 0;
			      field_disp(-1); /* ubN\Ȃ */
			obj = info_disp(obj);
			spcls(obj);
		}
	}
	locate(10, 5); /* mɏ܂ */
	printstr("     ");

	for(;;) {
		/* VubN擾܂B */
		gd.type = gd.next;
		gd.next = game_rand() % N_BLOCKS;

		/* VubN̏ʒu܂B
		 * ubN̈ԏtB[ḧԏɑ܂B
		 */
		gd.rot = 0;
		gd.x = (FIELD_COLS - BLOCK_COLS) / 2;
		block = &blocks[gd.type][gd.rot];
		for(i = 0; i < BLOCK_ROWS; i++) {
			for(j = 0; j < BLOCK_COLS; j++) {
				if((*block)[i][j]) break;
			}
			if(j < BLOCK_COLS) break;
		}
		gd.y = -i;

		/* osȂAQ[I[o[B */
		if(hit_test(gd.x, gd.y, gd.type, gd.rot)) break;

		/* o`Jn܂ł̍EړB */
		for(i = 0; i <= FLOAT_WAIT; i++) {
			schedule();

			/* EړB */
			block_work();

			/* \B */
			obj = 0;
			obj = field_disp(obj);
			obj = info_disp(obj);
			spcls(obj);

			/* nB */
			if(land_test()) {
				sound(SND_LAND);
				goto L_LAND;
			}

			/* JnB */
			if(joy & TRG_DN) break;
		}
L_FALL:
		/* ̍EړB */
		for(i = 0; i <= FALL_WAIT; i++) {
			schedule();

			/* EړB */
			block_work();

			/* \B */
			obj = 0;
			obj = field_disp(obj);
			obj = info_disp(obj);
			spcls(obj);

			/* nB */
			if(land_test()) {
				sound(SND_LAND);
				goto L_LAND;
			}

			/* B */
			if(joy & PAD_DN) {
				/* XRAZAnCXRAXVB */
				gd.score++;
				if(gd.score > hiscore) hiscore = gd.score;
				break;
			}
		}
		gd.y++;
		goto L_FALL;
L_LAND:
		/* n`ڒn܂ł̍EړB */
		for(i = 0; i <= LAND_WAIT; i++) {
			schedule();

			/* EړB */
			block_work();

			/* \B */
			obj = 0;
			obj = field_disp(obj);
			obj = info_disp(obj);
			spcls(obj);

			/* nB */
			if(!land_test()) {
				goto L_FALL;
			}
		}

		/* ubN̉܂B */
		block_put();

		/* sH */
		cnt = line_test();
		if(cnt != 0) {
			/* Aj[VB */
			for(i = 0; i <= LINE_WAIT; i++) {
				schedule();
				if(i % SEC(0.1) == 0) {
					for(y = 0; y < FIELD_ROWS; y++) {
						for(x = 0; x < FIELD_COLS; x++) {
							if(gd.field[y][x] >= 2) {
								gd.field[y][x]++;
							}
						}
					}
				}
				/* \B */
				obj = 0;
				      field_disp(-1); /* ubN\Ȃ */
				obj = info_disp(obj);
				spcls(obj);
			}

			/* ۂɏ܂B */
			line_erase();
			sound(SND_ERASE);

			/* _ZAnCXRAXVB
			 * 1s= 10pts
			 * 2s= 40pts
			 * 3s= 90pts
			 * 4s=160pts
			 */
			gd.score += cnt * cnt * 10;
			if(gd.score > hiscore) hiscore = gd.score;

			/* CZAxXVB */
			gd.line += cnt;
			while(gd.level < N_LEVELS) { /* x` */
				if(gd.line < levels[gd.level].next_line) break;
				gd.level++;
			}
			if(gd.level >= N_LEVELS) { /* x`Ȃ */
				gd.level = N_LEVELS + (gd.line - levels[N_LEVELS - 1].next_line) / 10;
			}
		}

		/* ڒn`NEXTo܂ł̃EFCgB */
		for(i = 0; i <= NEXT_WAIT; i++) {
			schedule();

			/* \B */
			obj = 0;
			      field_disp(-1); /* ubN\Ȃ */
			obj = info_disp(obj);
			spcls(obj);
		}
	}

	/* Q[I[o[bZ[W\B */
	sound(SND_GAMEOVER);
	for(i = 0; i < SEC(3); i++) {
		schedule();
		if(i % SEC(0.5) < SEC(0.33)) {
			obj = 0;
			obj = field_disp(obj);
			obj = info_disp(obj);
			spcls(obj);
			/* tB[hɏ㏑B */
			locate(10, 5);
			printstr("GAME");
			locate(11, 6);
			printstr("OVER");
		} else {
			obj = 0;
			      field_disp(-1); /* ubN\Ȃ */
			obj = info_disp(obj);
			spcls(obj);
		}
	}
	locate(10, 5); /* mɏ܂ */
	printstr("     ");
	locate(10, 6);
	printstr("     ");
}

/****************************************************************************
 *	game_rand
 ****************************************************************************/

int
game_rand()
{
	gd.seed = gd.seed * 5 + 0x3711;
	return gd.seed >> 8 & 0xff;
}

/****************************************************************************
 *	screen_disp
 ****************************************************************************/

/* Q[ʂ̕ςȂ`܂B */
void
screen_disp()
{
	/* ܂SNAB */
	cls();
	fill(0, 0, DISP_X-1, DISP_Y-1, 1);
	spcls(0);

	/* NEXT,LINE,LEVEL */
	fill(4*3-1, 4*1-1, 4*17, 4*15, 2);
	fill(4*3, 4*1, 4*17-1, 4*15-1, -1);
	locate(3, 1);
	printstr("NEXT");
	locate(3, 4);
	printstr("LINE");
	locate(3, 6);
	printstr("LEVEL");
	locate(3, 7);

	/* XRA */
	fill(4*3-1, 4*17-1, 4*17, 4*21, 2);
	fill(4*3, 4*17, 4*17-1, 4*21-1, -1);
	locate(2, 9);
	printstr("1P");
	locate(2, 10);
	printstr("HI");

	/* tB[h */
	fill(4*19-1, 4*1-1, 4*29, 4*21, 2);
	fill(4*19, 4*1, 4*29-1, 4*21-1, -1);
}

/****************************************************************************
 *	block_disp
 ****************************************************************************/

/* ݂̃ubN܂NEXTubN`܂B */
int
block_disp(int obj, int x, int y, int type, int rot)
{
	BLOCK* block;
	int i0, j0, i1, j1, chr, mask;

	block = &blocks[type][rot];

	for(i1 = 0; i1 < BLOCK_ROWS; i1 += 2) {
		for(j1 = 0; j1 < BLOCK_COLS; j1 += 2) {
			chr  = 0x10; /* XvCgpubNL̃x[Xԍ */
			mask = 0x01;
			for(i0 = 0; i0 < 2; i0++) {
				for(j0 = 0; j0 < 2; j0++) {
					if((*block)[i1 + i0][j1 + j0]) chr |= mask;
					mask <<= 1;
				}
			}
			spdisp(obj++, x + j1 * 4, y + i1 * 4, chr);
		}
	}

	return obj;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

/* tB[h`܂B */
int
field_disp(int obj)
{
	int x, y, i0, j0, i1, j1, chr, mask;

	x = 10; /* tB[h_̃eLXgW */
	y = 1;

	thread_lock();
	for(i1 = 0; i1 < FIELD_ROWS; i1 += 2) {
		for(j1 = 0; j1 < FIELD_COLS; j1 += 2) {
			chr  = 0x00; /* tB[hpubNL̃x[Xԍ */
			mask = 0x01;
			for(i0 = 0; i0 < 2; i0++) {
				for(j0 = 0; j0 < 2; j0++) {
					/* sƂ̃Aj[V̂߂ɁA
					 * bit1=1̏ꍇ̂݃ubN\܂B
					 */
					if(gd.field[i1 + i0][j1 + j0] & 1) chr |= mask;
					mask <<= 1;
				}
			}
			pclSpriteBGSetCharacter(0, x + j1 / 2, y + i1 / 2, chr);
		}
	}
	thread_unlock();

	x = x * 8 - 4; /* tB[h_̃XvCgW */
	y = y * 8 - 4;

	if(obj >= 0) {
		obj = block_disp(obj,
			x + gd.x * 4, y + gd.y * 4,
			gd.type, gd.rot);
	}

	return obj;
}

/****************************************************************************
 *	info_disp
 ****************************************************************************/

/* NEXTubNEC,x,XRA\B */
int
info_disp(int obj)
{
	/* NEXT */
	obj = block_disp(obj, 4*8, 4*3, gd.next, 0);

	/* C */
	locate(3, 5);
	siprintf("%5d", gd.line);

	/* x */
	locate(3, 7);
	siprintf("%5d", gd.level + 1); /* x1x[X */

	/* 1PXRA */
	locate(4, 9);
	siprintf("%5d", gd.score);

	/* nCXRA */
	locate(4, 10);
	siprintf("%5d", hiscore);

	return obj;
}

/****************************************************************************
 *	hit_test
 ****************************************************************************/

/* ubNZɏdȂĂ邩tB[hOȂA1Ԃ܂B */
int
hit_test(int x, int y, int type, int rot)
{
#if 0
	BLOCK* block;
	int i, j, x1, y1;

	block = &blocks[type][rot];

	for(i = 0, y1 = y; i < BLOCK_ROWS; i++, y1++) {
		for(j = 0, x1 = x; j < BLOCK_COLS; j++, x1++) {
			if(!(*block)[i][j]) continue; /* ubN̋ʒu͔΂ */
			if(x1 < 0 || FIELD_COLS <= x1) return 1;
			if(y1 < 0 || FIELD_ROWS <= y1) return 1;
			if(gd.field[y1][x1]) return 1;
		}
	}

	return 0;
#else /* ł͏肭ȂBx1y1CNgĂȂ͗lB             */
      /* dȂ̂ł܂B̊֐lłB                               */
	BLOCK* block;
	int i, j;

	block = &blocks[type][rot];

	for(i = 0; i < BLOCK_ROWS; i++) {
		for(j = 0; j < BLOCK_COLS; j++) {
			if(!(*block)[i][j]) continue; /* ubN̋ʒu͔΂ */
			if(x+j < 0 || FIELD_COLS <= x+j) return 1;
			if(y+i < 0 || FIELD_ROWS <= y+i) return 1;
			if(gd.field[y+i][x+j]) return 1;
		}
	}

	return 0;
#endif
}

/****************************************************************************
 *	land_test
 ****************************************************************************/

/* ubNZtB[h̒ɐڒnĂA1Ԃ܂B */
int
land_test()
{
	BLOCK* block;
	int i, j;

	block = &blocks[gd.type][gd.rot];

	for(i = 0; i < BLOCK_ROWS; i++) {
		for(j = 0; j < BLOCK_COLS; j++) {
			if(!(*block)[i][j]) continue; /* ubN̋ʒu͔΂ */
			if(gd.y+i == FIELD_ROWS - 1) return 1;
			if(gd.field[gd.y+i + 1][gd.x+j]) return 1;
		}
	}

	return 0;
}

/****************************************************************************
 *	block_put
 ****************************************************************************/

/* tB[hɃubN̉܂B */
void
block_put()
{
	BLOCK* block;
	int i, j;

	block = &blocks[gd.type][gd.rot];

	for(i = 0; i < BLOCK_ROWS; i++) {
		for(j = 0; j < BLOCK_COLS; j++) {
			if(!(*block)[i][j]) continue; /* ubN̋ʒu͔΂ */
			gd.field[gd.y+i][gd.x+j] = 1;
		}
	}
}

/****************************************************************************
 *	line_test
 ****************************************************************************/

/* sC̒l12ɕύX܂B
 * ߂ĺAs̐łB
 */
int
line_test()
{
	int cnt, x, y;

	cnt = 0;
	for(y = 0; y < FIELD_ROWS; y++) {
		for(x = 0; x < FIELD_COLS; x++) {
			/* ł󔒂΁AĂ܂B */
			if(!gd.field[y][x]) break;
		}
		/* Ăl2ɕύXAJEgAbv܂B */
		if(x == FIELD_COLS) {
			for(x = 0; x < FIELD_COLS; x++) {
				gd.field[y][x] = 2;
			}
			cnt++;
		}
	}

	return cnt;
}

/****************************************************************************
 *	line_erase
 ****************************************************************************/

/* sC܂B */
void
line_erase()
{
	int i, x, y;

	/* Ƃ͉Ȃ̂ŁAƍł܂A
	 * ͍vȂ̂ŁAPʂŒPɑg݂܂B
	 */
	for(y = 0; y < FIELD_ROWS; y++) {
		for(x = 0; x < FIELD_COLS; x++) {
			/* ̃ZĂ... */
			if(gd.field[y][x] >= 2) {
				/* ܂B */
				gd.field[y][x] = 0;
				/* ォ痎ƂB */
				for(i = y; i > 0; i--) {
					gd.field[i][x] = gd.field[i - 1][x];
				}
			}
		}
	}
}

/****************************************************************************
 *	block_work
 ****************************************************************************/

void
block_work()
{
	int prev_rot = gd.rot;
	int prev_x   = gd.x;

	/* ЎŗVׂ悤ɁA{^]ɊĂ܂B */
	if((joy & (TRG_B | TRG_UP)) && !hit_test(gd.x, gd.y, gd.type, (gd.rot + 1) & 3)) gd.rot = (gd.rot + 1) & 3;
	if((joy & TRG_A           ) && !hit_test(gd.x, gd.y, gd.type, (gd.rot - 1) & 3)) gd.rot = (gd.rot - 1) & 3;
	if((joy & TRG_LF          ) && !hit_test(gd.x - 1, gd.y, gd.type, gd.rot)) gd.x--;
	if((joy & TRG_RI          ) && !hit_test(gd.x + 1, gd.y, gd.type, gd.rot)) gd.x++;

	if(gd.rot != prev_rot || gd.x != prev_x) sound(SND_BLOCK);
}
